"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RCONPacketHandler = void 0;
const bufwrapper_1 = require("@minecraft-js/bufwrapper");
const node_process_1 = require("node:process");
const Int32LE_1 = require("../util/Int32LE");
const Packet_1 = require("./Packet");
class RCONPacketHandler {
    /**
     * Handle a packet
     * @param buffer Raw buffer
     * @returns The request ID and the packet
     */
    handle(buffer) {
        const buf = new bufwrapper_1.BufWrapper(buffer);
        const length = (0, Int32LE_1.readInt32LE)(buf);
        if (length + 4 !== buffer.length)
            (0, node_process_1.emitWarning)("Packet length doesn't match the length field of the packet");
        const requestId = (0, Int32LE_1.readInt32LE)(buf);
        const type = (0, Int32LE_1.readInt32LE)(buf);
        const packet = new Packet_1.RCONPacket(buf);
        packet.read(type);
        return { requestId, packet };
    }
}
exports.RCONPacketHandler = RCONPacketHandler;
